<?php

$path = dirname(__DIR__, 1);

return [
    'lean' => [
        'autoload' => [
            'lean.api',
        ]
    ],

    'ulmus' => [
        'connections' => [
            'lean.api' => [
                'adapter'  => getenv("LEAN_API_ADAPTER") ?: "SQLite",
                'path'     =>  getenv('PROJECT_PATH') . DIRECTORY_SEPARATOR . ( getenv("LEAN_API_PATH") ?: "var/lean-api.sqlite3" ),
                'pragma_begin' => array_merge(
                    explode(',', getenv("LEAN_API_PRAGMA_BEGIN") ?: "foreign_keys=ON,synchronous=NORMAL"),
                    explode(',', getenv('DEBUG') ? getenv("LEAN_API_PRAGMA_DEBUG_BEGIN") : "journal_mode=WAL")
                ),
                'pragma_close' => array_merge(
                    explode(',', getenv("LEAN_API_PRAGMA_CLOSE") ?: "analysis_limit=500,optimize"),
                    explode(',', getenv('DEBUG') ? getenv("LEAN_API_PRAGMA_DEBUG_CLOSE") : "")
                ),
            ],
        ]
    ]
];