<?php

namespace Lean\Api\ApplicationStrategy;

use DI\Attribute\Inject;
use Lean\Factory\HttpFactoryInterface;
use Picea\Picea;
use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;

class NotFoundDecorator extends \Lean\ApplicationStrategy\NotFoundDecorator
{
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        if (php_sapi_name() !== 'cli' and ! defined('STDIN'))  {
            return $this->throw404($request);
        }

        return parent::process($request, $handler);
    }

    public function throw404(ServerRequestInterface $request) : ResponseInterface
    {
        return $this->checkAssetTrigger($request) ?: $this->httpFactory->createJsonResponse([
            'status' => 'error',
            'message' => "Not Found",
            'ts' => time(),
        ], 404);
    }
}