<?php

namespace Lean\Api\Form;

use Lean\Api\Factory\MessageFactoryInterface;
use Lean\LanguageHandler;
use Picea\Ui\Method\FormContextInterface;
use Ulmus\Entity\EntityInterface;

trait FormTrait
{
    public function __construct(
        protected LanguageHandler $languageHandler,
        protected MessageFactoryInterface $message,
        # public EntityInterface $entity,
    ) {}

    public function initialize(FormContextInterface $context) : void
    {
        if(isset($this->contextClass) && ! $context instanceof $this->contextClass ) {
            throw new \LogicException(
                sprintf("Your context type should be a %s", $this->contextClass)
            );
        }
    }

    protected function lang(string $key, array $variables = [])
    {
        return $this->languageHandler->languageFromKey($key, $variables);
    }

    public function getEntity() : EntityInterface
    {
        if (! isset($this->entity)) {
            throw new \InvalidArgumentException($this->lang("lean.api.form.error.entity"));
        }

        return $this->entity;
    }

}